package com.google.android.DemoKit;

import android.content.res.Resources;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;

public class ButtonController implements OnClickListener {
	private final byte mCommandTarget;
	private DemoKitActivity mActivity;
	private Button mButton;

	public ButtonController(DemoKitActivity activity, int buttonNumber,
			Resources res) {
		mActivity = activity;
		mCommandTarget = (byte) (buttonNumber - 1);
	}

	public void attachToView(View targetView) {
		mButton = (Button) targetView;
		mButton.setOnClickListener(this);
	}

	@Override
	public void onClick(View v) {
		if (mActivity != null) {
			mActivity.sendCommand(DemoKitActivity.SET_DATE_COMMAND,mCommandTarget, 1);
		}		
	}

}
