package com.google.android.DemoKit;

import java.text.DecimalFormat;
//import java.util.ArrayList;

//import android.graphics.drawable.Drawable;
//import android.widget.ImageView;
import android.widget.TextView;

public class InputController extends AccessoryController {
	private TextView mTemperature;
	private TextView mLightView;
	private TextView mLightRawView;
	private TextView mCpmView;
	private TextView mCpm10View;
	private TextView mCpmLastTimeView;
	private TextView mCpmRealView;
	private TextView mCpvView;
//	private JoystickView mJoystickView;
//	ArrayList<SwitchDisplayer> mSwitchDisplayers;
	private final DecimalFormat mLightValueFormatter = new DecimalFormat("##.#");
	private final DecimalFormat mTemperatureFormatter = new DecimalFormat(
			"###" + (char)0x00B0);
	private final DecimalFormat mCpmFormatter = new DecimalFormat("###");
	private final DecimalFormat mCpmLastTime = new DecimalFormat("##");

	InputController(DemoKitActivity hostActivity) {
		super(hostActivity);
		mTemperature = (TextView) findViewById(R.id.tempValue);
		mLightView = (TextView) findViewById(R.id.lightPercentValue);
		mLightRawView = (TextView) findViewById(R.id.lightRawValue);
		mCpmView = (TextView) findViewById(R.id.cpmValue);
		mCpm10View = (TextView) findViewById(R.id.cpm10Value);
		mCpmLastTimeView = (TextView) findViewById(R.id.cpmLastTimeValue);
		mCpmRealView = (TextView) findViewById(R.id.cpmRealValue);
		mCpvView = (TextView) findViewById(R.id.cpvValue);
//		mJoystickView = (JoystickView) findViewById(R.id.joystickView);
	}

	protected void onAccesssoryAttached() {
//		mSwitchDisplayers = new ArrayList<SwitchDisplayer>();
//		for (int i = 0; i < 4; ++i) {
//			SwitchDisplayer sd = new SwitchDisplayer(i);
//			mSwitchDisplayers.add(sd);
//		}
	}

	public void setTemperature(int temperatureFromArduino) {
		/*
		 * Arduino board contains a 6 channel (8 channels on the Mini and Nano,
		 * 16 on the Mega), 10-bit analog to digital converter. This means that
		 * it will map input voltages between 0 and 5 volts into integer values
		 * between 0 and 1023. This yields a resolution between readings of: 5
		 * volts / 1024 units or, .0049 volts (4.9 mV) per unit.
		 */
//		double voltagemv = temperatureFromArduino * 4.9;
//		double ambientTemperatureC = (voltagemv * 20.0) / 1024.0;

//		mTemperature.setText(mTemperatureFormatter.format(ambientTemperatureC));
		mTemperature.setText(mTemperatureFormatter.format(temperatureFromArduino));
	}

	public void setCpmValue(int cpmValueFromArduino) {
		mCpmView.setText(mCpmFormatter.format(cpmValueFromArduino));
	}

	public void setCpm10Value(int cpm10ValueFromArduino) {
		mCpm10View.setText(mCpmFormatter.format(cpm10ValueFromArduino));
	}
	
	public void setCpmLastTimeValue(int cpmLastTimeHHValueFromArduino,
			int cpmLastTimeMMValueFromArduino) {
		mCpmLastTimeView.setText(mCpmLastTime.format(cpmLastTimeHHValueFromArduino) + ':' + 
				mCpmLastTime.format(cpmLastTimeMMValueFromArduino));
	}

	public void setCpmRealValue(int cpmRealValueFromArduino) {
		mCpmRealView.setText(mCpmFormatter.format(cpmRealValueFromArduino));
	}
	
	public void setCpvValue(int cpvValueFromArduino) {
		mCpvView.setText(mCpmFormatter.format(cpvValueFromArduino));
	}
	
	public void setLightValue(int lightValueFromArduino) {
		mLightRawView.setText(String.valueOf(lightValueFromArduino));
		mLightView.setText(mLightValueFormatter
				.format((100.0 * (double) lightValueFromArduino / 1024.0)));
	}

/*	public void switchStateChanged(int switchIndex, boolean switchState) {
		if (switchIndex >= 0 && switchIndex < mSwitchDisplayers.size()) {
			SwitchDisplayer sd = mSwitchDisplayers.get(switchIndex);
			sd.onSwitchStateChange(switchState);
		}
	}

	public void joystickButtonSwitchStateChanged(boolean buttonState) {
		mJoystickView.setPressed(buttonState);
	}

	public void joystickMoved(int x, int y) {
		mJoystickView.setPosition(x, y);
	}
*/
	public void onTemperature(int temperature) {
		setTemperature(temperature);
	}

	public void onLightChange(int lightValue) {
		setLightValue(lightValue);
	}

	public void onCpmChange(int cpmValue) {
		setCpmValue(cpmValue);
	}
	
	public void onCpm10Change(int cpm10Value) {
		setCpm10Value(cpm10Value);
	}

	public void onCpmLastTimeChange(int cpmLastTimeHHValue, int cpmLastTimeMMValue) {
		setCpmLastTimeValue(cpmLastTimeHHValue, cpmLastTimeMMValue);
	}
	
	public void onCpmRealChange(int cpmRealValue) {
		setCpmRealValue(cpmRealValue);
	}

	public void onCpvChange(int cpvValue) {
		setCpvValue(cpvValue);
	}
/*	
	public void onSwitchStateChange(int switchIndex, Boolean switchState) {
		switchStateChanged(switchIndex, switchState);
	}

	public void onButton(Boolean buttonState) {
		joystickButtonSwitchStateChanged(buttonState);
	}

	public void onStickMoved(int x, int y) {
		joystickMoved(x, y);
	}

	class SwitchDisplayer {
		private final ImageView mTargetView;
		private final Drawable mOnImage;
		private final Drawable mOffImage;

		SwitchDisplayer(int switchIndex) {
			int viewId, onImageId, offImageId;
			switch (switchIndex) {
			default:
				viewId = R.id.Button1;
				onImageId = R.drawable.indicator_button1_on_noglow;
				offImageId = R.drawable.indicator_button1_off_noglow;
				break;
			case 1:
				viewId = R.id.Button2;
				onImageId = R.drawable.indicator_button2_on_noglow;
				offImageId = R.drawable.indicator_button2_off_noglow;
				break;
			case 2:
				viewId = R.id.Button3;
				onImageId = R.drawable.indicator_button3_on_noglow;
				offImageId = R.drawable.indicator_button3_off_noglow;
				break;
			case 3:
				viewId = R.id.Button4;
				onImageId = R.drawable.indicator_button_capacitive_on_noglow;
				offImageId = R.drawable.indicator_button_capacitive_off_noglow;
				break;
			}
			mTargetView = (ImageView) findViewById(viewId);
			mOffImage = mHostActivity.getResources().getDrawable(offImageId);
			mOnImage = mHostActivity.getResources().getDrawable(onImageId);
		}

		public void onSwitchStateChange(Boolean switchState) {
			Drawable currentImage;
			if (!switchState) {
				currentImage = mOffImage;
			} else {
				currentImage = mOnImage;
			}
			mTargetView.setImageDrawable(currentImage);
		}

	}*/
}
