package com.google.android.DemoKit;

import android.content.res.Resources;
import android.view.View;
import android.widget.CompoundButton;
import android.widget.CompoundButton.OnCheckedChangeListener;
import android.widget.ToggleButton;

public class ToggleButtonController implements OnCheckedChangeListener {
	private final byte mCommandTarget;
	private DemoKitActivity mActivity;
	private ToggleButton mButton;

	public ToggleButtonController(DemoKitActivity activity, int relayNumber,
			Resources res) {
		mActivity = activity;
		mCommandTarget = (byte) (relayNumber - 1);
	}

	public void attachToView(View targetView) {
		mButton = (ToggleButton) targetView;
		mButton.setOnCheckedChangeListener(this);
	}

	public void onCheckedChanged(CompoundButton arg0, boolean isChecked) {
		if (mActivity != null) {
			mActivity.sendCommand(DemoKitActivity.LED_COMMAND,
					mCommandTarget, isChecked ? 1 : 0);
		}
	}

}
