#define PORT_DIR_A 12
#define PORT_DIR_B 13

#define PORT_PWM_A 3
#define PORT_PWM_B 11

#define PORT_BRAKE_A 9
#define PORT_BRAKE_B 8

#define PORT_CURRENTSENSE_A A0
#define PORT_CURRENTSENSE_B A1
void controlMotor(boolean motor_r_fwd,boolean motor_l_fwd,byte motor_r_power,byte motor_l_power);

void setup()
{
  // ポートの初期設定を行う
  pinMode(PORT_DIR_A,OUTPUT);
  pinMode(PORT_DIR_B,OUTPUT);
  pinMode(PORT_PWM_A,OUTPUT);
  pinMode(PORT_PWM_B,OUTPUT);
  pinMode(PORT_BRAKE_A,OUTPUT);
  pinMode(PORT_BRAKE_B,OUTPUT);

  digitalWrite(PORT_DIR_A,LOW);
  digitalWrite(PORT_DIR_B,LOW);
  digitalWrite(PORT_BRAKE_A,LOW);
  digitalWrite(PORT_BRAKE_B,LOW);
  analogWrite(PORT_PWM_A,0);
  analogWrite(PORT_PWM_B,0);
}

void loop()
{
  // モーターを駆動
  controlMotor(true,true,255,255);
  // 3秒待つ
  delay(3000);
  // モーターを駆動
  controlMotor(false,false,255,255);
  // 3秒待つ
  delay(3000);
}

void controlMotor(boolean motor_r_fwd,boolean motor_l_fwd,byte motor_r_power,byte motor_l_power)
{
  if(motor_r_power == 0){
    digitalWrite(PORT_BRAKE_A,HIGH);
  } 
  else {
    digitalWrite(PORT_BRAKE_A,LOW);
  }    
  if(motor_l_power == 0){
    digitalWrite(PORT_BRAKE_B,HIGH);
  } 
  else {
    digitalWrite(PORT_BRAKE_B,LOW);
  }    

  digitalWrite(PORT_DIR_A,motor_r_fwd == false ? HIGH : LOW);
  digitalWrite(PORT_DIR_B,motor_l_fwd == false ? HIGH : LOW);

  analogWrite(PORT_PWM_A,motor_r_power);
  analogWrite(PORT_PWM_B,motor_l_power);
}


